#include <gtk/gtk.h>
enum {
    COL_NAME = 0,
    COL_AGE,
    NUM_COLS
};
GtkBuilder *builder;



static GtkTreeModel *create_and_fill_model(void) {
    GtkListStore *store;
    GtkTreeIter iter;
    
    store = gtk_list_store_new(NUM_COLS, G_TYPE_STRING, G_TYPE_UINT);
    gtk_list_store_append(store, &iter);
    gtk_list_store_set(store, &iter, COL_NAME, "Jan Kowalski", COL_AGE, 21, -1);

    gtk_list_store_append(store, &iter);
    gtk_list_store_set (store, &iter, COL_NAME, "Piotr Nowak", COL_AGE, 43, -1);

    gtk_list_store_append(store, &iter);
    gtk_list_store_set(store, &iter, COL_NAME, "Paweł Szczepanek", COL_AGE, 91, -1);
    
    return GTK_TREE_MODEL(store);
}

static GtkWidget *init_view_and_model(void) {
    GtkCellRenderer *renderer;
    GtkTreeModel *model;
    GtkWidget *treeview;
    
    treeview = GTK_WIDGET(gtk_builder_get_object(builder, "TreeView"));

    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(treeview), -1, "Nazwisko", renderer, "text", COL_NAME, NULL);

    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(treeview), -1, "Wiek", renderer, "text", COL_AGE, NULL);
    
    model = create_and_fill_model();
    gtk_tree_view_set_model(GTK_TREE_VIEW(treeview), model);
    g_object_unref(model);

    return treeview;
}


int main(int argc, char **argv) {
    GtkWidget *window;
    GtkWidget *treeview;
    GError *error;
    
    gtk_init(&argc, &argv);
    
    builder = gtk_builder_new();
	error = NULL;
	gtk_builder_add_from_file(builder, "prosta_lista_gtktreeview.ui", &error);
	if (error) {
		g_print("Wystąpił błąd: %s\n", error->message);
		g_error_free(error);
		return -1;
	}
    
	window = GTK_WIDGET(gtk_builder_get_object(builder, "MainWindow"));
    g_signal_connect(window, "delete_event", gtk_main_quit, NULL);
    
    init_view_and_model();

    gtk_widget_show_all(window);
    gtk_main();

    return 0;
}
